combine.menu <- function(action, window)
{
  dialog <- gtkDialogNewWithButtons("Combine Gates", window, "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])
    
 
    gtkWidgetSetSizeRequest(dialog, 400, 400)
    
    namebox <- gtkHBox(FALSE, 0)
    dialog[["vbox"]]$packStart(namebox, FALSE, FALSE, 5)
     
    label <- gtkLabelNew("Gate name : ")
    from <- gtkEntryNew()
    from$setText("combined gate")
    from$"has-focus" <- TRUE
    namebox$packStart(label, FALSE, FALSE, 0)
    namebox$packStart(from, TRUE, TRUE, 0)
  
  
    gates <- names(.guiEnv$Gate.list)
    ops <- c("&", "|", "!" )
   
    main.box <- gtkHBox(TRUE, 10)
    dialog[["vbox"]]$packStart(main.box, TRUE, TRUE, 0)
  
    view <-make.treeview(gates, "Gate List", "multiple")
    sw1 <- make.scrolled_window(view)
   
    main.box$packStart(sw1, TRUE, TRUE, 0)
    
    opview <-make.treeview(ops, "Operation", "single")
    sw2<- make.scrolled_window(opview)
     
    main.box$packStart(sw2, TRUE, TRUE, 0)
  
    diag.run<- dialog$run()
    
    if(diag.run == GtkResponseType["ok"])
    {
        inds<-getSelectedIndices(view)
      
        ind<-getSelectedIndices(opview)
     
        name <- from$getText()
        if(name %in% names(.guiEnv$Gate.list))
        {
            while(name %in% names(.guiEnv$Gate.list))
            {  
              name <- paste(name, "*")
            }  
        }  
           
        ## for warning messages
        if(length(ind) == 0 || length(inds) == 0)
        {  
                show.message("Select a operation or gate")
                return()
        }
        
        if (ind == 3 && length(inds) != 1)
        {
            show.message("Select one parameter for a complement (!) operation")
            return()
        }     
        
        if (ind != 3 && length(inds) != 2)
        {
             show.message("Select two parameters for the operation (& or |)")
             return()
        }
        
        if(length(inds) == 2){
            left <- .guiEnv$Gate.list[[inds[1]]]
            right <-.guiEnv$Gate.list[[inds[2]]]
            selection(ind, left, right, name)
        }
        
        if(length(inds) == 1)
        {  
           right <- .guiEnv$Gate.list[[inds[1]]]
           selection(ind, left = NULL, right, name)
        }
      }
      dialog$destroy()
    
}


