compensation.menu <- function(action, window)
{
    dialog <- gtkDialogNewWithButtons("Compensation", window, "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])
    
    a <- gtkLabel("Apply a following spillover matrix to the data.")                                      
    dialog[["vbox"]]$packStart(a, FALSE, FALSE, 5)
    
    cfile <- system.file("extdata","compdata","compmatrix", package="flowCore")
    comp.mat <- read.table(cfile, header=TRUE, skip=2, check.names = FALSE)
    a <- colnames(comp.mat)
    
    first.col  <- comp.mat[,1]
    second.col <- comp.mat[, 2]
    third.col <- comp.mat[,3]
    fourth.col <- comp.mat[, 4]
    
    mat <- gtkHBox(FALSE, 0)
    dialog[["vbox"]]$packStart(mat, FALSE, FALSE, 0)
    
    first.view <- make.treeview(first.col, a[1], "none")
    mat$packStart(first.view, TRUE, TRUE, 0) 
    
    second.view <- make.treeview(second.col, a[2], "none")
    mat$packStart(second.view, TRUE, TRUE, 0)
    
    third.view <- make.treeview(third.col, a[3], "none")
    mat$packStart(third.view, TRUE, TRUE, 0)
    
    fourth.view <- make.treeview(fourth.col, a[4], "none")
    mat$packStart(fourth.view, TRUE, TRUE, 0)
    
    if (dialog$run() == GtkResponseType["ok"]){
          comp <- compensation(as.matrix(comp.mat))
          addSubNode(comp, suffix = "compensation")
    }
    dialog$destroy()
    
}

