create.stat.tree.view <- function(model, result)
{
    tree.view <- gtkTreeView(model)
    sapply(seq_len(ncol(result)),
           function(w){
               renderer <- gtkCellRendererText()
               column <- gtkTreeViewColumn(colnames(result)[w], renderer, text = w)
               column$setSortColumnId(w)
               column$setCellDataFunc(renderer,
                                      function(column, renderer, model, iter)
                                  {
                                      q <- model$getPath(iter)$getIndices()[[1]] +1
                                      renderer["text"] <- as.character(result[q, w])
                                  })
               tree.view$appendColumn(column)
           })
    tree.view$setHeadersClickable(TRUE)
    if(is.null(gtkCheckVersion(2, 10, 0)))
        tree.view$setGridLines("both")
    tree.view
}

