##### drag and drop ######

drop_get <- function(wgt, context, x, y, seldata, info, time, userdata)
{

   str <- gtkSelectionDataGetText(seldata)
   name <- rawToChar(str)

   ind <- which(name == names(.guiEnv$Gate.list))
   gate <-.guiEnv$Gate.list[[ind]]
   if(class(gate) == "rangeFilter"){
   	   rg <-rangeGate(activeFlowset(), gate@parameters[[1]]@parameters)
   	   gate <- rg
   }
  
   i <- y %/% 20
   j <- y %% 20

   if(j <= 0 && j < 5 )
        i <- i-1
  
   tryCatch( dnd(i, gate, x, y),
             error = function(e) {
                     m <- paste("Error: ", conditionMessage(e))
                     error.handler(m)
                 }, 
                 warning = function(e) {
                     m <- paste("Warning: ", conditionMessage(e))
                     warning.handler(m)
                     
                 })
} 

dnd<-function(i, gate, x, y){
 
      if(i > length(.guiEnv$global.node.list) || i == length(.guiEnv$global.node.list) ) 
               i <- length(.guiEnv$global.node.list)
  
      ind <- 0
      tt <- 0
  
      for(k in 1:length(names(iget("workflow.list")))){
            tt <- tt + length(views(iget("workflow.list")[[k]]))
            if(tt > i || tt == i) { ind <- k
                                    break()
                                   } }
  
     iset("active.workflow", names(iget("workflow.list"))[ind])
     wf <-activeWorkflow()
  
     treepath <- gtkTreeViewGetDestRowAtPos(iget("dataSetTreeView"), x, y)$path
     inds <- gtkTreePathGetIndices(treepath) + 1L 
  
     ##activeNodeId
     node.ind <- which(names(.guiEnv$global.node.list) == paste(inds, collapse = "_"))
     old <-.guiEnv$global.node.list[node.ind]
    
     ##activeNodename
     nm <- flowCore:::nameIdMapping(activeWorkflow())[old[[1]]]
     if (nm == "base view") nm <- activeWorkflow()@name
   
     old.nodes <- nodes(activeWorkflow())
     add(activeWorkflow(), gate,
          parent = old[[1]],
          name = getNewName("Enter a name for the flow set",
                              sprintf("%s_%s", nm, "gate")))
    new.nodes <- setdiff(nodes(activeWorkflow()), old.nodes)
    new.names <- flowCore:::nameIdMapping(activeWorkflow())[new.nodes]
   
    sapply(seq_along(new.nodes),
           function(q) {
               node.path <- add.node.bydnd(new.names[q], treepath)
               updateGlobalNodelist(node.path, new.nodes[q])
            })
}  

drag_get <- function(wgt, context, seldata, info, time, userdata)
{   
    
    inds<-getSelectedIndices(wgt)
    name<- names(.guiEnv$Gate.list)[inds]
  
    gtkSelectionDataSetText(seldata, name)
}   

add.node.bydnd <- function(node.name, treepath)
{
   model <- iget("model")
   parent.iter <- model$getIter(treepath)$iter
   iter <- model$append(parent.iter)$iter
   model$set(iter, 0, node.name)
   model$getPath(iter)$GetIndices() + 1
}


