draw.backgating.graph <- function( button, pview,  title,  view, sview)
{
 tryCatch(
             {
             	  cur_node <- iget("cur_node")
                  wf <- activeWorkflow()
                  gating <- .guiEnv$Gate.list
             	            
	          parent_node <- parent(wf[[cur_node]])@name
	          node_label <- which(views(wf) == parent_node) 
	          dat <- Data(wf[[views(wf)[node_label]]])   
	          
	          ## find index of a selected filter in a gate list
                  actionId <-action(wf[[cur_node]])@name
                  ind <- gate.action(actionId)
                  filter.result <- filter(dat, .guiEnv$Gate.list[[ind]])
                
                  if(length(gating[[ind]]@parameters) == 1)
                  { 	  
                  	  xx <- gating[[ind]]@parameters[[1]]@parameters
                  	
                  	  frame <- make.data.frame(dat, filter.result)
                  	  
                  	  x<-frame[, xx]
                	  sample<-frame[, "sample"]
                	  filter <- frame[, "filter"]
                	  
                	  frm <- data.frame(cbind(y, sample, filter))
                  	  plot(densityplot(~ frm$x | frm$sample, groups = frm$filter, xlab = xx, pch = ".", main = cur_node))
                  	  
                  	  view <- NULL
                  	  	  
                  }
                  else{
               	          xx <- gating[[ind]]@parameters[[1]]@parameters
                	  yy <- gating[[ind]]@parameters[[2]]@parameters
                	  
                	  frame <- make.data.frame(dat, filter.result) 
                	  
                	  y<-frame[, yy]
                	  x<-frame[, xx]
                	  sample<-frame[, "sample"]
                	  filter <- frame[, "filter"]
                	  
                	  frm <- data.frame(cbind(x, y, sample, filter))
                	 
                	  plot(xyplot(frm$y ~ frm$x |frm$sample, data = frm, groups = frm$filter, xlab = xx, ylab = yy,
                	  smooth = FALSE,  pch = ".", par.settings =list(fill = "black", col= "red", alpha = 0.4), main = cur_node))
                              	
                      }
               
              gSignalConnect(button, "clicked", backgating.cb, list(pview, title, cur_node, view, sview, frame)) 
               	    
              },
                 error = function(e) {
                     m <- paste("Error:", conditionMessage(e))
                     error.handler(m)
                 }, 
                 warning = function(e) {
                     m <- paste("Warning:", conditionMessage(e))
                     warning.handler(m)
                 }
        )
        pop <- 1
        iset("pop", pop)
        if(class(wf[[parent_node]]) == "gateView")
        {
         	
           cur_node <- parent_node
           iset("cur_node", cur_node)
          
           openGraphics( mode=4)
                    
        }
       
}  

draw.gating.graphics <- function()
{
	 tryCatch(
          { 
	
                 inds <- iget("value.x")
                 dat <- activeFlowset()
                    
                 gating <- .guiEnv$Gate.list
             
                 for(i in 1:length(inds))
                 {
                     if(i == 1) title <- paste(activeNodeName(),names(gating[inds[1]]), sep="_" )
                     else title <- paste(title, names(gating[inds[i]]), sep="_")
                  
                     filter.result <- filter(dat, gating[[inds[i]]])      
                     wf <- activeWorkflow()
                     nm <- activeNodeName()
                   
                     if(length(gating[[inds[i]]]@parameters) == 2) {
                               	        
                          if(class(.guiEnv$Gate.list[[inds[i]]]) == "rectangleGate") {             
                     	              parm1<- names(gating[[inds[i]]]@min)[1]
                                      parm2 <-names(gating[[inds[i]]]@min)[2] }  
                          else{
                          	      parm1 <- gating[[inds[i]]]@parameters[[1]]@parameters
                     	              parm2 <- gating[[inds[i]]]@parameters[[2]]@parameters  }    
                     	              
                     	              a<-list(gate=list(fill="red", col="red", alpha=0.3), gate.text=list(col="black", alpha=0.9, cex=0.6))
                     	              form <- sprintf("`%s` ~ `%s`",parm2 ,parm1)
                               
                     	             if(class(gating[[inds[i]]]) == "lymphFilter") 
                     	             {
                     	             	lng <- length(views(wf))                           
                     	             	lg <- lymphGate(Data(wf[[views(wf)[lng]]]), channels = c(parm2, parm1), 
                     	             	       preselection = gating[[inds[i]]]@preselection, filterId = "TCells")
                     	             	add(wf, lg$n2gate, parent = nm)
                     	             	dt <- wf[["TCells+"]]
                     	             	fcall <- sprintf("xyplot(%s, dt, outline=TRUE, names=TRUE, main = title, par.settings = a)", form)
                     	             	plot(eval(parse(text = fcall)))
                     	             	Rm("TCells-",wf)
                     	             	Rm("TCells+", wf)
                     	             }
                     	             else{
                     	               	            
                                        fcall <- sprintf("xyplot(%s, data=dat, filter=filter.result, smooth=TRUE, outline=TRUE, names=TRUE, main = title, par.settings = a)", form)
                                        plot(eval(parse(text = fcall)))
                                      }}
                      else{
                      	    
                      	     parm <- gating[[inds[i]]]@parameters[[1]]@parameters 
                      	     if(class(gating[[inds[i]]]) == "kmeansFilter")
                      	     	     densityplot(~.,Data(wf[[nm]]), channels=c(parm), scales=list(y=list(draw=F)), filter=lapply(parm, kmeansFilter))
                      	     if(class(gating[[inds[i]]]) == "curv1Filter")
                      	    	     densityplot(~.,Data(wf[[nm]]), channels=c(parm), scales=list(y=list(draw=F)), filter=lapply(parm, curv1Filter))
                         
                     if(length(inds) > 1){
                          small <- summary(filter.result)  
                          sub_dat <- Subset(dat, gating[[inds[i]]])
                          make.contents(sub_dat,small)
                          dat <- sub_dat
                     }
                     
  #                   dev.set(dev.next())
                             
                    }
                 }
              },
                 error = function(e) {
                     m <- paste("Error:", conditionMessage(e))
                     error.handler(m)
                 }, 
                 warning = function(e) {
                     m <- paste("Warning:", conditionMessage(e))
                     warning.handler(m)
                 }
            
                 )
        pop <- 1
        iset("pop", pop)
 #        dev.set(dev.next())
	
}	
