filter.menu <-
    function(action, window)
{
    dialog <- gtkDialogNewWithButtons("Select a gate", window, "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])
    
   
    vbox <- gtkVBox(FALSE, 5)
    choices <- c("Rectangle Gate","Range Gate", "Quadrant Gate", "Lymphcyte Gate" , "Kmeans", "Norm2 Gate", "Curv1 Gate", 
    "Curv2 Gate", "Manual Gate")
    radio_buttons <- NULL
    
    for (choice in choices){
        button <- gtkRadioButton(radio_buttons, choice)
        vbox$add(button)
        radio_buttons <- c(radio_buttons, button)
    }
    
    dialog[["vbox"]]$packStart(vbox, FALSE, FALSE, 5)
    
   
    
    if (dialog$run() == GtkResponseType["ok"])
    {  
        mode <- 2
        buttons <- button$getGroup()
        act <- which(sapply(buttons, gtkToggleButtonGetActive))
      
        switch(act,  
                     "1" = gate.menu(action, window),
                     "2" = curv2(mode),
                     "3" = curv1(mode),
                     "4" = norm2(mode),
                     "5" = k_mean(mode),
                     "6" = lymph(mode),
                     "7" =  quad(mode), 
                     "8" = range(mode),
                     "9" = rect(mode),
                     stop("unknown plot type"))
      }  
      dialog$destroy()
}

