graph.selection <-
    function(..., 
             active = NULL, dt = NULL,
             value.x = NULL, value.y = NULL,
             variable.x = NULL, variable.y = NULL)
{
    value.x <- iget("value.x")
    value.y <- iget("value.y")
    ## put fset in .guiEnv so that evaluateCommand() sees it
    if(length(iget("selected.graphics.subset")) != 0)
    {     
          active <- iget("graphics.choice")    
          cat("graph.selection called with active: ", active, "\n")
          iset("fset", activeFlowset()[iget("selected.graphics.subset") ] )
          
      }      
     else 
     {
        ### for probBin plot
        active <- "probbin"
        dfrm <- iget("dfrm")
        iset("fset", dfrm)
     } 
    
    fset <- iget("fset")
    switch(active,
           "splom"={ ## scatter plot matrix
               evaluateCommand("plot(splom(fset[[1]][, value.x]))")
           },
           "parallel"={ ## Parallel
               evaluateCommand("plot(parallel(fset[[1]][, value.x], alpha = 0.01))")
           },
           "histogram"={ ## Histogram
               if (FALSE) ## FIXME: write histogram method
               {
                   evaluateCommand("plot(histogram(fset))")
               }
               else 
               {
                   if (length(iget("selected.graphics.subset")) == 1)
                       evaluateCommand("plot(fset[[1]], value.x, breaks = 256)")
                   else{
                       show.message("Not implemented yet...")
                   }
               }
           },
           "density"={## Density plot
               evaluateCommand("plot(densityplot(~ ., data = fset, channels = value.x))")
                                       
           },
           "contour"={## Contour
                      ###FIXME : IT HAS TO EVALUATE COMMAND.
                       plot(fset[[1]], c(value.x, value.y))
                       contour(fset[[1]], add=TRUE, col="red", lty = 3)
             },
           "timeline"={## timeLinePlot
               evaluateCommand("timeLinePlot(fset, value.x)")
           },
           "ecdf"={## ecdfPlot
               ## FIXME: should also work for multiple parameters
               
               if(length(variable.x) != 0){
               	   form <- sprintf(" ~ `%s` | `%s`", value.x, variable.x )
                   fcall <- sprintf("plot(ecdfplot(%s, data = fset, strip = strip.custom(strip.names = TRUE), ref = FALSE, auto.key = list(columns = 4)))", form)
                   evaluateCommand(fcall)  
               }
               else{
                   form <- sprintf(" ~ `%s`", value.x)
                   fcall <- sprintf("plot(ecdfplot(%s, fset))", form) 
                   evaluateCommand(fcall)  
               }
           },
           "qqplot"={## qqmath
               ## FIXME: should also work for multiple parameters
##                     
               form <- sprintf(" ~ `%s`", value.x)
               fcall <- sprintf("plot(qqmath(%s, fset, grid = TRUE, f.value=ppoints(100)), auto.key = list(columns = 2))", form) 
               evaluateCommand(fcall)  
##            
           },
          "smooth.xy"={
               evaluateCommand(sprintf("plot(xyplot(`%s`~`%s`, data = fset))",
                                       value.y, value.x))
           },
           "dot.plot"={
               evaluateCommand(sprintf("plot(xyplot(`%s`~`%s`, data = fset, smooth = FALSE))",
                                       value.y, value.x))
           },
           stop("unknown plot type"))
}


