help.filter.menu <-
    function(action, window)
{
    dialog <- gtkDialogNewWithButtons("About Filter", window, "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"])
    dialog$setSizeRequest(400, 250)                                  
    
    hbox <- gtkHBox(TRUE, 0)
    dialog[["vbox"]]$packStart(hbox, TRUE, TRUE, 0)
    
    plotlist <- c("RectangleGate", "Kmeans", "Norm2Filter")
    
                                        # show the list of plots
    hw1 <- gtkScrolledWindowNew(NULL, NULL)
    hw1$setShadowType("etched-in")
    hw1$setPolicy("automatic", "automatic")

    hbox$packStart(hw1, TRUE, TRUE, 0) 
    
    con <- rGtkDataFrame(data.frame(cols = plotlist))
    plotview <- gtkTreeView(con)
    col <- gtkTreeViewColumn("Filter", gtkCellRendererText(), text = 0)
    plotview$insertColumn(col, 0)
    plotview$getSelection()$setMode("single")
    sel <- plotview$getSelection()
    
    hw1$add(plotview)
    
                                        # explain the requested plot 
    hw2 <- gtkScrolledWindowNew(NULL, NULL)
    hw2$setShadowType("etched-in")
    hw2$setPolicy("automatic", "automatic")

    hbox$packStart(hw2, TRUE, TRUE, 0)
    
    help.info <- c("Present explanation for a",  "selected filter method")
    hcon <- rGtkDataFrame(data.frame(cols = help.info))
    help.info.view <- gtkTreeView(hcon)
    hcol <- gtkTreeViewColumn("Information", gtkCellRendererText(), text = 0)
    help.info.view$insertColumn(hcol, 0)
    help.info.view$getSelection()$setMode("none")
    
    hw2$add(help.info.view)
    
    gSignalConnect(sel, "changed", help.filter.cb, list(con, plotview, hcon))
    dialog$run()
    dialog$destroy()      
}

