normal.menu <- function(action, window)
{

    dialog <- gtkDialogNewWithButtons("Normalization", window, "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])
  
    gtkWidgetSetSizeRequest(dialog, 300, 400)
    
    df <- activeFlowset()
    
    if(length(flowCore:::findTimeChannel(df)) != 0)
         channels <-colnames(df)[-(which(colnames(df) == "Time"))]
    else  
         channels <- colnames(df)
      
    tree <- make.treeview(channels, "Channels", "multiple")
    sw <-make.scrolled_window(tree)
    
    func <- c("warpSet", "gpaSet", "gaussNorm")
    tree1 <- make.treeview(func, "Function", "single")
    sw1 <-make.scrolled_window(tree1)
    
    hbox<- gtkHBox(FALSE, 5)
    hbox$packStart(sw, TRUE, TRUE, 0)
    hbox$packStart(sw1, TRUE, TRUE, 0)
    
    dialog[["vbox"]]$packStart(hbox, TRUE, TRUE, 0)
   
    if (dialog$run() == GtkResponseType["ok"])
    {
          ## for channels
          inds <- getSelectedIndices(tree)
          ## for function
          func.name <- getSelectedIndices(tree1)
          
          norm <- switch(func.name, 
                       "1" = { 
                               tryCatch(               
                                       {    
                                         normalization(normFun=function(x, parameters, ...)
                                         warpSet(x, parameters, ...), 
                                         parameters = channels[inds], arguments = list(grouping = NULL))
                                         },
                                        error = function(e) {
                                        m <- paste("Error :", conditionMessage(e))
                                        error.handler(m)
                                     }
                               )                  
                        }, 
                       "2"={ title <- "gpaSet" 
                             tryCatch(               
                                     {                 
                                        gpaset.func(inds, channels, title)
                                     },
                                        error = function(e) {
                                        m <- paste("Error :", conditionMessage(e))
                                        error.handler(m)
                                     }
                               ) 
                         # normalization(normFun=function(x, parameters, ...)
                         #    gpaSet(x, parameters, ...), 
                         #    parameters = channels[inds], arguments = list(grouping = NULL))
                        },
                       "3"={  
                             tryCatch(               
                                     {  
                                       normalization(normFun=function(x, parameters, ...)
                                                     gaussNorm(x, parameters, ...), 
                                                     parameters = channels[inds], arguments = list(grouping = NULL))
                                       },
                                        error = function(e) {
                                        m <- paste("Error :", conditionMessage(e))
                                        error.handler(m)
                                     }
                               )                 
                        }, 
                        stop("unknown function type"))
                
          tryCatch(               
          {
             addSubNode(norm, suffix = "normalization")
          },
             error = function(e) {
             m <- paste("Error :", conditionMessage(e))
             error.handler(m)
           }
         )
    }
  dialog$destroy()


}
