open.menu <-
    function(action, window)
{
    if (is.null(iget("last.folder")))
        iset("last.folder", getwd())
    dialog <- gtkFileChooserDialog("Select FCS files or RDA file", window, "open",
                                   "gtk-open", GtkResponseType["accept"],
                                   "gtk-cancel", GtkResponseType["cancel"])
    dialog$setSizeRequest(700, 500)                                   
    gtkFileChooserSetCurrentFolder(dialog, iget("last.folder"))
    dialog$setSelectMultiple(TRUE)
    if (dialog$run() == GtkResponseType["accept"])
    {
        fselected <- unlist(dialog$getFilenames())
        cat("Selected files are: \n")
        print(fselected)
        tryCatch(loadFiles(filenames = fselected), 
                 ## if error happens, show up another dialog to notify error message and destroy dialog for open menu
                 error = function(e) {
                     m <- paste("Error: ", conditionMessage(e))
                     error.handler(m)
                 }, 
                 warning = function(e) {
                     m <- paste("Warning: ", conditionMessage(e))
                     warning.handler(m)
                     
                 })
        if (length(fselected))
            iset("last.folder", dirname(fselected[1]))
    }
    dialog$destroy()
}

