pop.up.menu <-
    function(event, ptree.view, action)
{
    menu <- gtkMenuNew(TRUE) 
    gtkWidgetSetSizeRequest(menu, 200, 250)
    #gSignalConnect (menu, "deactivate", G_CALLBACK (gtkWidgetDestroy()), NULL);
    first.item <- gtkMenuItem("Subset")
    second.item <- gtkMenuItem("Plot")
    menu$attach(first.item, 0,1,0,1)
    menu$attach(second.item, 0,1,1,2)
    menu$popup(button = event[["button"]], activate.time=event[["time"]])
    gSignalConnect(first.item, "activate", pop.up.subset.cb, ptree.view)
    gSignalConnect(second.item, "activate", pop.up.plot.cb, c(ptree.view, action))
}



pop.up.plot.cb <- function(second.item, info)
{
    ptree.view <- info[[1]]
    action <- info[2]
    model <- ptree.view$getModel()
    paths <- ptree.view$getSelection()$getSelectedRows()$retval
    inds <- sapply(paths, gtkTreePathGetIndices) + 1L
    iset("use.graphics.subset", TRUE)
    graphics.menu(action, iget("window"))
}


pop.up.subset.cb <- 
    function(first.item, ptree.view)
{
    addSubNode(activePhenoSubset(), suffix = "sub")
}




## for the pop up menu from a filter list
pop.up.menu1 <-
    function(event, ptree.view, action)
{
    menu <- gtkMenuNew(TRUE) 
    gtkWidgetSetSizeRequest(menu, 100, 80)
    first.item <- gtkMenuItem("Summary")
    second.item <- gtkMenuItem("Plot")
    menu$attach(first.item, 0,1,0,1)
    menu$attach(second.item, 0, 1, 1, 2)
    menu$popup(button = event[["button"]], activate.time=event[["time"]])
    gSignalConnect(first.item, "activate", summary.cb, ptree.view)
    gSignalConnect(second.item, "activate", graph.cb, ptree.view)
}

graph.cb <- function(second.item, ptree.view)
{
   ind <-  getSelectedIndices(ptree.view)
   iset("value.x", ind)
   openGraphics(ind, mode = 2)	
	
}	

 
make.contents <- function(x, smallset)
{
   fs <- x
   small <- smallset
   
   name <- NULL
   true <- NULL 
   count <- NULL 
   p <- NULL
   
   for(i in 1:length(fs))
   {
      nm <-sampleNames(fs)[i]
      tr <- small[[i]]@true
      ct <- small[[i]]@count
      pro <- (small[[i]]@p)*100
      pro <- sprintf("%f %%", pro)
   
      name <- c(name, nm)
      true <- c(true, tr)
      count <- c(count, ct)
      p <- c(p, pro)
    
    }  
    names <- NULL
    counts <- NULL
    if(length(name) == length(true)){  
         result <- data.frame(name, true, count, p)
         rownames(result) <- name
         colnames(result) <- c("Sample", "Gated population", "Total Events", "Proportion")
    }     
    else{ ## for kmeans result
         a <- length(true)/length(name)
         for(j in 1:length(name))
         {
             namelist <- NULL
             countlist <- NULL
             for(k in 1:a){
                 namelist <-c(namelist, name[j])
                 countlist <-c(countlist, count[j])
             }
             names <- c(names, namelist)
             counts <- c(counts, countlist)
         }
         lab <- names(true)
         a <-sprintf("%d", true)
         trues <-as.numeric(a)
         result <- data.frame(names, lab, trues, counts, p)
         name <- names 
         colnames(result) <- c("Sample", "Levels", "Gated population", "Total Events", "Proportion")
    }
        
    type <- 2
    showStat(type, result, NULL) 	
	
}	
 

summary.cb <- function(first.item, ptree.view)
{
   fs <- activeFlowset() 
   ind <-  getSelectedIndices(ptree.view)
   gate <-.guiEnv$Gate.list[[ind]]
   
   if(class(gate) == "rangeFilter"){
   	   rg <- rangeGate(fs, gate@parameters[[1]]@parameters)
           gate <- rg   }
           
   small <- summary(filter(fs, gate)) 
   
   make.contents(fs, small)
  
}  
