probin.menu <-
    function(action, window)
{
   dialog <- gtkDialogNewWithButtons("Probability Binning", window, "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])
                                      
   dat <- activeFlowset()
 
      
     if(!is(dat, "flowSet")){
        dat <- as(dat, "flowSet")
     } 
     
     main.box <- gtkHBox(TRUE, 10)
     main.box$setSizeRequest(600, 500)
     dialog[["vbox"]]$packStart(main.box, TRUE, TRUE, 0)
    
    frame <- rev(sampleNames(dat))
   
    if(length(dat) != 1){
             
        # for the view of frame variables          
        frdf <- rGtkDataFrame(data.frame(cols=rev(frame)))
        fview <- gtkTreeView(frdf)
        fcol <- gtkTreeViewColumn("Select one or two frames", gtkCellRendererText(), text = 0)
        fview$insertColumn(fcol, 0)
        fview$getSelection()$setMode("multiple")
        fsel <- fview$getSelection()
        
        sw <- gtkScrolledWindowNew(NULL, NULL)
        sw$setShadowType("etched-in")
        sw$setPolicy("automatic", "automatic")
        sw$add(fview)
        
        main.box$packStart(sw, TRUE, TRUE, 0)
    
     }   

    ## The channel list first
    channel <- colnames(dat)   
    rdf <- rGtkDataFrame(data.frame(cols=channel))
    view <- gtkTreeView(rdf)
    col <- gtkTreeViewColumn("X Channel", gtkCellRendererText(), text = 0)
    view$insertColumn(col, 0)
    view$getSelection()$setMode("single")
    
    sw2 <- gtkScrolledWindowNew(NULL, NULL)
    sw2$setShadowType("etched-in")
    sw2$setPolicy("automatic", "automatic")
    sw2$add(view)
    main.box$packStart(sw2, TRUE, TRUE, 0)
    
    ## A container to hold the selected channel variables
    yrdf <- rGtkDataFrame(data.frame(cols=channel))
    yview <- gtkTreeView(yrdf)
    ycol <- gtkTreeViewColumn("Y Channel", gtkCellRendererText(), text = 0)
    yview$insertColumn(ycol, 0)
    yview$getSelection()$setMode("single")
      
    sw3 <- gtkScrolledWindowNew(NULL, NULL)
    sw3$setShadowType("etched-in")
    sw3$setPolicy("automatic", "automatic")
    sw3$add(yview)
    main.box$packStart(sw3, TRUE, TRUE, 0)
    
    if (dialog$run() == GtkResponseType["ok"]){
             
        frame <- rev(frame)
        path <- fview$getSelection()$getSelectedRows()$retval
        inds <- sapply(path, gtkTreePathGetIndices)
        frame <- frame[inds+1]
                
        path <- view$getSelection()$getSelectedRows()$retval
        inds <- sapply(path, gtkTreePathGetIndices)
        x <- channel[inds+1]
        iset("value.x", x)
        
        path <- yview$getSelection()$getSelectedRows()$retval
        inds <- sapply(path, gtkTreePathGetIndices)
        y <- channel[inds+1]
        iset("value.y", y)
        
        if(length(frame) != 0){
            dfrm <- dat[frame] 
            if(length(frame) == 1){
                
                variable.x <- NULL
                resCtrl <- proBin(dfrm[[1]], 200)
                variable.y <- resCtrl
                iset("variable.y", variable.y)
                
                iset("dfrm", dfrm)
                openGraphics(mode = 5)   
             
            }
            else if(length(dfrm) == 2){
               
                dfrm <-dat[frame]
                
                resCtrl <- proBin(dfrm[[1]], 200)
                resSample<-binByRef(resCtrl,dfrm[[2]])
                
                stat<-calcPearsonChi(resCtrl,resSample)
                
                variable.y <- resCtrl
                iset("variable.y", variable.y)
                
                variable.x <- stat
                iset("variable.x", variable.x) 
                                
                iset("dfrm", dfrm)
                openGraphics(mode = 5)   
                
               
                val <- stat$statistic
                par <- stat$parameter
                p <- format.pval(stat$p.value)
                
                result <- sprintf("X-squared = %s, df = %s, p-value  %s", val, par, p)
                
                residuals <- stat$residuals
                
                res<-as.data.frame(residuals)
                                
                type <- 1
                showStat(type, res, NULL)
                
            }
            else{
                show.message(m = "It only works for two or one frame.")
            }
        }
        else
            show.message(m = "Please select frames.")
        
    }    
    dialog$destroy()
    
}     

