manipulations <- function(func)
{
      df <- activeFlowset() 
      res <- fsApply(df, each_col, func)
      name <- sampleNames(df)
      res <- cbind(name, res)
      result <- as.data.frame(res)
      type <- 2
      showStat(type, result, NULL)
}  

customize <- function(window)
{
  dialog <- gtkDialogNewWithButtons("Define a function", window, "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])
                                      
  entry <- gtkEntryNew() 
    
  dialog[["vbox"]]$packStart(entry, FALSE, FALSE, 10)                                      
    
  if (dialog$run() == GtkResponseType["ok"])
  {
     df <- activeFlowset() 
     own <- entry$getText()
     form <- sprintf("%s",own)
     fcall <- sprintf("res <- fsApply(df, %s, use.exprs = TRUE)", form)
     res <- evaluateCommand(fcall) ## FIXME: want more things inside evaluateCommand() ?
     name <- sampleNames(df)
     res <- cbind(name, res)
     result <- as.data.frame(res)
     type <- 2
     showStat(type, result, NULL)
  }
  dialog$destroy()
}  


stat.menu <- function(action, window)
{
    dialog <- gtkDialogNewWithButtons("Statistics", window, "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])
    
    choices <- c("median", "mean", "min", "max", "Customize...")
    
    rdf <- rGtkDataFrame(data.frame(cols=choices))
    view <- gtkTreeView(rdf)
    col <- gtkTreeViewColumn("Select a function for statistics.", gtkCellRendererText(), text = 0)
    view$insertColumn(col, 0)
    view$getSelection()$setMode("single")
    dialog[["vbox"]]$packStart(view, FALSE, FALSE, 5)
    
            
    if (dialog$run() == GtkResponseType["ok"])
    {
       path <- view$getSelection()$getSelectedRows()$retval
       inds <- sapply(path, gtkTreePathGetIndices)
       func <- choices[inds+1]
       if(func != "Customize...")
           manipulations(func)
       else
           customize(window)
    }  
    dialog$destroy()
    
}

