sub_filter.menu <- function(action, window)
{
     if(is.null(.guiEnv$Gate.list))
     {  
           show.message("There is no information of filters.\n")
           return()
     }      
         
        dialog <- gtkDialogNewWithButtons("Subset", window, "destroy-with-parent", 
                                          "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])

        gtkWidgetSetSizeRequest(dialog, 230, 400)
        
        label <- gtkLabelNew("Select a gate for a subset")  
        dialog[["vbox"]]$packStart(label, FALSE, FALSE, 10)
       
        
        gates <- names(.guiEnv$Gate.list)
        
        view <- make.treeview(gates, "Gate List", "single")
        sw<-make.scrolled_window(view)
        dialog[["vbox"]]$packStart(sw, TRUE, TRUE, 0)
     
        if(dialog$run() == GtkResponseType["ok"])
        {
            inds<-getSelectedIndices(view)
            gating <- .guiEnv$Gate.list[[inds]]
            
            tryCatch( if(class(gating) == "rangeFilter")
                      {  
            	        rg<-rangeGate(activeFlowset(), gating@parameters[[1]]@parameters)
              	        addSubNode(rg, suffix = gates[inds])
                      }              
                      else
                      {	      
                          addSubNode(gating, suffix = gates[inds])},
            ## if error happens, show up another dialog to notify error message and destroy dialog for open menu
            
                      error = function(e) {
                           m <- paste("Error: ", conditionMessage(e))
                           error.handler(m)
                       }, 
                      warning = function(e) {
                           m <- paste("Warning: ", conditionMessage(e))
                           warning.handler(m)
                     
             })  
        }      
        dialog$destroy()    
        
  
}

