sub_pdata.menu <- function(action, window)
{
    pdata <- pData(activeFlowset())
    if (nrow(pdata) == 0)
    {
        show.message("No active dataset")
        return()
    }
    if (nrow(pdata) == 1) 
    {
        show.message("Active flowset has only one frame.")
        return()
    }
    dialog <- gtkDialogNewWithButtons("Subsetting details", window,
                                      "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"],
                                      "gtk-cancel", GtkResponseType["cancel"])
    
    frame <- gtkFrame("Subset")
    dialog[["vbox"]]$packStart(frame, FALSE, FALSE, 0)
    
    vbox <- gtkHBox(FALSE, 10)
    vbox$setSizeRequest(250, 300)
    frame$add(vbox)
    
    ## pheno data selection
    pheno <- colnames(pdata)
    
    ## for the view of pData variables 
   # pview <- make.view(pheno, "Object", "single" )
    prdf <- rGtkDataFrame(data.frame(cols=pheno))
    pview <- gtkTreeView(prdf)
    pcol <- gtkTreeViewColumn("Covariate", gtkCellRendererText(), text = 0)
    pview$insertColumn(pcol, 0)
    pview$getSelection()$setMode("single")
    sel <- pview$getSelection()
    
    sw <- make.scrolled_window(pview)
    
    vbox$packStart(sw, TRUE, TRUE, 0)
    
    ## for the values of the variables
    selcol <- NULL
    prdf.sel <- rGtkDataFrame(data.frame(cols=selcol))
    pview.sel <- gtkTreeView(prdf.sel)
    pcol.sel <- gtkTreeViewColumn("Values", gtkCellRendererText(), text = 0)
    pview.sel$insertColumn(pcol.sel, 0)
    pview.sel$getSelection()$setMode("multiple")
    
    sw1 <- gtkScrolledWindowNew(NULL, NULL)
    sw1$setShadowType("etched-in")
    sw1$setPolicy("automatic", "automatic")
    sw1$add(pview.sel)
    vbox$packStart(sw1, TRUE, TRUE, 0)  
    
    type <- 2
    gSignalConnect(sel, "changed", x.pheno.cb, list(pheno, pview, prdf.sel, type))
    
    if(dialog$run() == GtkResponseType["ok"])
    {
        ins <- getSelectedIndices(pview)
        if(length(ins) == 0) 
             show.message(m = "Please select the variable.")
           
        x <- pheno[ins]
        a <- getSelectedIndices(pview.sel)
        
        if (length(a) == 0) 
              show.message("Please select values.")
            
        y <- prdf.sel[a, ]                                                    
        selected.samples <- which(pdata[[x]] %in% y)
        dialog$destroy()
        addSubNode(selected.samples, suffix = "sub")
    }
    else dialog$destroy()
}



