trans.menu <-
    function(action, window)
{
      if (!isAnyActive()) 
    {
        show.message("No active dataset")
        return()
    }
    
    dialog <- gtkDialogNewWithButtons("Transformation", window, "destroy-with-parent", 
                                      "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])
    
    gtkWidgetSetSizeRequest(dialog, 500, 400)
    hbox <- gtkHBox(TRUE, 5)
       
    method <- c("linear", "ln", "log", "logicle", "arcsinh","biexponential","scale", "quadratic")
    channels <- colnames(activeFlowset())
    
    ## for method
    mview <- make.treeview(method, "Method", "single")
    sw <- make.scrolled_window(mview)
    hbox$packStart(sw, TRUE, TRUE, 0)
  
    view <- make.treeview(channels, "Channels", "multiple")
    sw1 <- make.scrolled_window(view)
   
    hbox$packStart(sw1, TRUE, TRUE, 0)
   
    dialog[["vbox"]]$packStart(hbox, TRUE, TRUE, 0)
      
    if (dialog$run() == GtkResponseType["ok"]){
       
       path <- mview$getSelection()$getSelectedRows()$retval
       inds <- sapply(path, gtkTreePathGetIndices)
       mth <- method[inds+1]
       
       path <- view$getSelection()$getSelectedRows()$retval
       inds <- sapply(path, gtkTreePathGetIndices)
       flist <- channels[inds+1]
        
       na <- paste(flist, collapse = " ")
       expl <- paste("Method :", mth, ",Transformed measurement :", na )
       tmethod <- list(NULL, NULL, expl)
       iset("tmethod", tmethod)
        
       
       iset("trans_mode", TRUE )  
       transformation(mth, flist)
       iset("trans_mode", FALSE)
    }  
    dialog$destroy() 
}

