transformation <- function(mth, flist)
{
    ## expl is for transformation info.
    flist <- as.vector(flist)
    df <- activeFlowset()
    
    trans <-
        switch(mth, 
               "linear" = {
                   linear <- linearTransform("linear")
                   transformList(flist, linear)
               },
               "ln" = {
                   ln <- lnTransform("ln")
                   transformList(flist, ln)
               },
               "log" = {
                   log <- logTransform("log")  
                   transformList(flist, log)
               },
               "logicle" = {
                   logicle <- logicleTransform("logicle")  
                   transformList(flist, logicle)
               },
               "arcsinh" = {
                   arcsinh <-arcsinhTransform("arcsinh")  
                   transformList(flist, arcsinh)
               },
               "biexponential" = {
                   biexponential <- biexponentialTransform("biexponential")
                   transformList(flist, biexponential)
               },
               "scale" = {
                   scale <- scaleTransform("scale")
                   transformList(flist, scale)
               },
               "quadratic" = {
                   quadratic <- quadraticTransform("quadratic")
                   transformList(flist,  quadratic)
               })

    ## trans_dt <- trans %on% df

### FIXME: allow user to specify name of ew subsets (What if there are
### more than one, such as a quadGate?)
           
    addSubNode(trans, suffix = "trans")
   
}


